=== debian/changelog ===
passwordsafe (1.12.0+dfsg-1) unstable; urgency=medium

  [ William Blough ]
  * Update tarball sig name in d/watch
  * New upstream version 1.12.0+dfsg
  * Refresh patches
  * Run upstream tests via autopkgtest (Closes: #971494)

 -- William Blough <bblough@debian.org>  Mon, 21 Dec 2020 12:21:24 -0500

passwordsafe (1.11.0+dfsg-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Bill Blough ]
  * Update gpg signature match in watch file
  * New upstream version 1.11.0+dfsg
  * Refresh patches
  * Install ReleaseNotes.md instead of ReleaseNotes.txt

 -- William Blough <bblough@debian.org>  Fri, 18 Sep 2020 23:12:19 -0400
